FreeBSD Administration - Support #607

Install Odoo 8 on FreeBSD
04/28/2015 02:17 PM - Daniel Curtis

Status: Closed Start date: 04/28/2015
Priority: Normal Due date:

Assignee: Daniel Curtis % Done: 100%
Category: Accounting Server Estimated time: 3.00 hours
Target version: FreeBSD 9 Spent time: 8.00 hours
Description

This is a guide for install OpenERP 8, Odoo, on FreeBSD 9. The Odoo installer supports FreeBSD, so all that needs to be done is
install a few dependencies and run the installer.

Setting up the Environment

e Start by making sure everything is up to date:

pkg update && pkg upgrade
portsnap fetch extract

e Install portmaster:

cd /usr/ports/ports-mgmt/portmaster
make install clean

pkg2ng
® [nstall dependencies from ports

portmaster textproc/py-libxml2 textproc/py-xlwt devel/py-pytz lang/py-mx-base databases/py-psy
copg?2 graphics/py-chart graphics/py-pydot textproc/py-libxslt devel/py-lxml textproc/py-xml de
vel/py-yaml textproc/py-mako devel/py-dateutil print/py-reportlab www/py-werkzeug deskutils/py
-vobject finance/py-vatnumber devel/py-unittest2 devel/py-simplejson www/py-requests textproc/
py-grcode devel/py-usb security/py-openid net/py-ldap2 comms/py-serial print/py-pdf devel/py-p
arsing databases/py-psycogreen databases/py-psycopg?2 sysutils/py-psutil graphics/py-pillow sec
urity/py-passlib devel/py-mock devel/py-gevent textproc/py-feedparser devel/py-decorator conve
rters/wkhtmltopdf x1l-fonts/webfonts

o NOTE: | came across a problem with a pyparsing version preventing the setup.py script to work properly. | found that |
needed to uninstall devel/py-pyparsing and replace it with devel/py-pyparsing15:

cd /usr/ports/devel/py-parsing
make deinstall clean
portmaster devel/py-pyparsinglb

e (Optional) Install the dependencies using pkgng:

pkg install py27-1libxml2 py27-xlwt py27-pytz py27-mx-base py27-psycopg2 py27-chart py27-pydot
py27-1libxslt py27-1xml py27-yaml py27-mako py27-dateutil py27-reportlab py27-werkzeug py27-vob
ject py27-vatnumber py27-unittest2 py27-simplejson py27-requests py27-grcode py27-usb py27-ope
nid py27-ldap py27-serial py27-pdf py27-pyparsing py27-psycogreen py27-psycopg2 py27-psutil py
27-pillow py27-passlib py27-mock py27-gevent py27-feedparser py27-decorator wkhtmltopdf

e Add the OpenERP user
pw add user -n openerpd -m -s /bin/sh -c "OpenERP"

Install Odoo

* Make and switch to the /usr/local/src directory:

mkdir /usr/local/src
cd /usr/local/src

e Download the latest nightly version of Odoo:

fetch 'https://nightly.odoo.com/8.0/nightly/src/odoo_8.0.latest.tar.gz'
tar xzf odoo_8.0-latest.tar.gz
cd odoo-8.0-*

e |nstall using the setup script:

python2 setup.py install

e Set ownership of odoo to the openerpd user:

chown —-R openerpd:wheel /usr/local/lib/python2.7/site-packages/odoo-8.0%*
o NOTE: The path may need to be changed to fit the odoo path.
Configure Odoo

e Create a basic odoo config file:

vi /usr/local/etc/openerp-server.conf

o And add the following:

[options]

; This is the password that allows database operations:

; admin_passwd = admin

db_host = pg.example.com

db_port = 5432

db_user = odoouser

db_password = odoodb

addons_path = /usr/local/lib/python2.7/site-packages/0doo-8.0_20150510-py2.7.egg/openerp/a
ddons/

o NOTE: If using the nightly builds the addons_path may need to be changed to suit the path odoo was installed to.
Odoo rc script

e First make a directory for the openerpd pid

mkdir /var/run/openerpd
chown openerpd /var/run/openerpd
® Create a new rc script for odoo:

vi /usr/local/etc/rc.d/openerpd

o And add the following:

#!/bin/sh

#

# PROVIDE: openerpd

# REQUIRE: postgresgl LOGIN

#

# Add the following lines to /etc/rc.conf to enable openerp-server

#

#

# openerpd_enable (bool): Set to "NO" by default,

# Set it to "YES" to enable openerp-server

#

# openerpd_config (str): The path to the openerp-server configuration file
# (defaults to /usr/local/etc/openerp-server.conf)
#

# openerpd_flags (str): Extra arguments to be used when invoking

# the openerp-server daemon.

#

# openerpd_addons (str): The path to the openerpd addons.

#

# Patch submitted by (c) Franck Porcher, Ph.D, to fix some issues regarding
# pidfile, log files, and discrepencies with the main configuration file.

/etc/rc.subr

name=openerpd
command=/usr/local/bin/openerp-server
rcvar=openerpd_enable

load_rc_config S$name

openerpd_enable="${openerpd_enable-"NO"}"
openerpd_config="${openerpd_config-"/usr/local/etc/openerp-server.conf"}"
openerpd_user="${openerpd_user-"openerpd"}"
openerpd_pidfile="${openerpd_pidfile:-"/var/run/openerpd/openerpd.pid"}"
openerpd_logdir="${openerpd_logdir:-"/var/log/openerpd.log"}"

openerpd_flags="${openerpd_flags:-"--config=${openerpd_config} —--pidfile=${openerpd_pidfil

e} —--logfile=${openerpd_logdir} "}"

# /etc/rc.subr use $pidfile (not ${name}_pidfile)
pidfile="${openerpd_pidfile}"

required_files="${openerpd_config}"

start_cmd="su - ${openerpd_user} -c 'S${command} S${openerpd_flags}' &"
stop_cmd="5${name}_stop"

status_cmd="${name}_status"

getval_cmd="${name}_getval"

openerpd_stop ()
{

openerpd_pid=$ (pgrep -f "openerp-server")

echo "Stopping ${name}."
kill -s TERM "$(cat "S$S{openerpd_pidfile}")"

echo "Stopping ${name}."
kill -s TERM "${openerpd_pid}"
openerpd_status ()

{

# Try its best to find the service's status

if [ -f "${openerpd_pidfile}" ]
then
openerpd_pid="$ (cat "S${openerpd_pidfile}")"
fi
if [ -z "${openerpd_pid}" ]
then
openerpd_pid=$ (pgrep -f "openerp-server")
[ -=n "${openerpd_pid}" ] && echo "${openerpd_pid}" > "S${openerpd_pidfile}"
fi

if [ -n "${openerpd_pid}" ]

then
echo "${name} running with pid: $openerpd_pid"
else
echo "${name} not running? (pid not found)"
fi
}
command_args=" >/dev/null 2>&1 &"

load_rc_config $name
run_rc_command "S$1"

o Make the script executable:

chmod +x /usr/local/etc/rc.d/openerpd

e Start and enable odoo at boot:

echo 'openerpd_enable="YES"' >> /etc/rc.conf

service openerpd start

o NOTE: If the server does not start, try to start it manually and look for any output:

su —-m openerpd —-c 'sh -c "/usr/local/bin/openerp-server —-config=/usr/local/etc/openerp-se

rver.conf"'

e Now navigate to http://odoo.example.com:8069 to complete the installation process.

(Optional) Install Odoo from GitHub

¢ Add the OpenERP user

pw add user -n openerpd -m -s /bin/sh -c "OpenERP"
* Remove openldap-client and py27-ldap:

pkg remove openldap-client py27-ldap

® Reinstall py27-ldap from ports, enabling [X] SASL
http://odoo.example.com:8069

portmaster net/py-ldap

o Enable [X] GSSAPI in the openldap-client port.

® [nstall pip:

pkg install py27-pip

e Make and switch to the /usr/local/src directory:

mkdir /usr/local/src
cd /usr/local/src

e Download Odoo from GitHub:

git clone -b 8.0 https://www.github.com/odoo/odoo
cd odoo

e |nstall the odoo dependencies using pip:

pip install -r requirements.txt

¢ Now install odoo:

python2 setup.py install

¢ Next copy the addons from the git repo to the install directory:

cp -r /usr/local/src/odoo/addons/* /usr/local/lib/python2.7/site-packages/odoo-8.0-py2.7.egg/o
penerp/addons/

e Set ownership of odoo to the openerpd user:

chown —-R openerpd:wheel /usr/local/lib/python2.7/site-packages/odoo—-8.0%*

o NOTE: The path may need to be changed to fit the odoo path.

Configure Odoo

* Create a basic odoo config file:

vi /usr/local/etc/openerp-server.conf

o And add the following:

[options]

; This is the password that allows database operations:
; admin_passwd = admin

db_host = pg.example.com

db_port 5432

db_user = odoouser

db_password = odoodb
addons_path = /usr/local/lib/python2.7/site-packages/odoo-8.0-py2.7.egg/openerp/addons/

o NOTE: If using the nightly builds the addons_path may need to be changed to suit the path odoo was installed to.
Odoo rc script

e First make a directory for the openerpd pid

mkdir /var/run/openerpd
chown openerpd /var/run/openerpd

e Create a new rc script for odoo:

vi /usr/local/etc/rc.d/openerpd

o And add the following:

#!/bin/sh

#

# PROVIDE: openerpd

# REQUIRE: postgresgl LOGIN

#

# Add the following lines to /etc/rc.conf to enable openerp-server

#

#

# openerpd_enable (bool): Set to "NO" by default,

# Set it to "YES" to enable openerp-server

#

# openerpd_config (str): The path to the openerp-server configuration file
# (defaults to /usr/local/etc/openerp-server.conf)
#

# openerpd_flags (str): Extra arguments to be used when invoking

# the openerp-server daemon.

#

# openerpd_addons (str): The path to the openerpd addons.

#

# Patch submitted by (c) Franck Porcher, Ph.D, to fix some issues regarding
# pidfile, log files, and discrepencies with the main configuration file.

/etc/rc.subr

name=openerpd
command=/usr/local/bin/openerp-server
rcvar=openerpd_enable

load_rc_config $name

openerpd_enable="${openerpd_enable-"NO"}"
openerpd_config="${openerpd_config-"/usr/local/etc/openerp-server.conf"}"
openerpd_user="${openerpd_user-"openerpd"}"
openerpd_pidfile="${openerpd_pidfile:-"/var/run/openerpd/openerpd.pid"}"
openerpd_logdir="${openerpd_logdir:-"/var/log/openerpd.log"}"
openerpd_flags="${openerpd_flags:-"--config=${openerpd_config} —--pidfile=${openerpd_pidfil
e} —--logfile=${openerpd_logdir} "}"

# /etc/rc.subr use $pidfile (not ${name}_pidfile)
pidfile="${openerpd_pidfile}"

required_files="${openerpd_config}"

start_cmd="su - ${openerpd_user} -c '${command} ${openerpd_flags}' &"
stop_cmd="${name}_stop"

status_cmd="${name}_status"

getval_cmd="${name}_getval"

openerpd_stop ()
{
openerpd_pid=$ (pgrep -f "openerp-server")

echo "Stopping ${name}."
kill -s TERM "$(cat "S$S{openerpd_pidfile}")"

echo "Stopping ${name}."
kill -s TERM "${openerpd_pid}"

openerpd_status ()
{
# Try its best to find the service's status
if [ -f "$S{openerpd_pidfile}" ]
then
openerpd_pid="$ (cat "S${openerpd_pidfile}")"
fi

if [ -z "${openerpd_pid}" ]

then
openerpd_pid=$ (pgrep —-f "openerp-server")
[ -n "${openerpd_pid}" ] && echo "${openerpd_pid}" > "S${openerpd_pidfile}"
fi
if [ -n "${openerpd_pid}" ]
then
echo "${name} running with pid: $openerpd_pid"
else
echo "${name} not running? (pid not found)"
fi
}
command_args=" >/dev/null 2>&1 &"

load_rc_config $name
run_rc_command "S$1"

o Make the script executable:
chmod +x /usr/local/etc/rc.d/openerpd

e Start and enable odoo at boot:
echo 'openerpd_enable="YES"' >> /etc/rc.conf
service openerpd start

o NOTE: If the server does not start, try to start it manually and look for any output:

su —-m openerpd -c 'sh -c "/usr/local/bin/openerp-server —-config=/usr/local/etc/openerp-se
rver.conf"'

Creating a Dummy Theme

® |nstall less from NPM:
npm install -g less less—-plugin-clean-css

e Fetch odoo.py from GitHub:

04/24/2024 7/10




cd /usr/local/lib/python2.7/site-packages/odoo—-8.0_20150510-py2.7.egg/openerp/
wget -0 odoo.py https://raw.githubusercontent.com/odoo/odoo/8.0/0doo.py

e Create a new scaffold theme:

python2 odoo.py scaffold -t theme "New Theme" addons

e Restart Odoo:

service openerpd restart

* Now go to Settings and install the new theme

h2. Resources

¢ http://zewaren.net/site/?q=node/127
¢ https://github.com/odoo/odoo
¢ https://www.odoo.com/documentation/8.0/setup/install.html

e https://github.com/odoo/odoo/issues/4604

History

#1 - 04/28/2015 02:32 PM - Daniel Curtis
- Description updated

- Status changed from New to In Progress

#2 - 05/06/2015 08:07 PM - Daniel Curtis
- Description updated

- % Done changed from 0 to 40

#3 - 05/06/2015 10:10 PM - Daniel Curtis
- Description updated

- % Done changed from 40 to 50

#4 - 05/06/2015 10:45 PM - Daniel Curtis

- Description updated

#5 - 05/07/2015 07:50 AM - Daniel Curtis
- Description updated

- % Done changed from 50 to 60

#6 - 05/07/2015 10:45 AM - Daniel Curtis
- Description updated
- % Done changed from 60 to 70

#7 - 05/07/2015 11:20 AM - Daniel Curtis

- Description updated

#8 - 05/07/2015 11:39 AM - Daniel Curtis
- Description updated

- % Done changed from 70 to 80

#9 - 05/07/2015 05:12 PM - Daniel Curtis

- Description updated
https://github.com/odoo/odoo
https://www.odoo.com/documentation/8.0/setup/install.html
#10 - 05/07/2015 08:34 PM - Daniel Curtis
- Description updated
- % Done changed from 80 to 90

#11 - 05/08/2015 07:10 AM - Daniel Curtis

- Description updated

#12 - 05/08/2015 07:26 AM - Daniel Curtis

- Description updated

#13 - 05/08/2015 07:33 AM - Daniel Curtis

- Description updated

#14 - 05/08/2015 07:45 AM - Daniel Curtis

- Description updated

#15 - 05/08/2015 08:10 AM - Daniel Curtis

- Estimated time changed from 5.00 h to 3.00 h

#16 - 05/08/2015 02:22 PM - Daniel Curtis

- Description updated

#17 - 05/08/2015 04:49 PM - Daniel Curtis

- Description updated

#18 - 05/09/2015 08:33 PM - Daniel Curtis

- Description updated

#19 - 05/09/2015 08:53 PM - Daniel Curtis

- Description updated

#20 - 05/09/2015 09:53 PM - Daniel Curtis
- Description updated

- % Done changed from 90 to 100

#21 - 05/10/2015 08:20 AM - Daniel Curtis

- Status changed from In Progress to Resolved

#22 - 05/10/2015 09:20 AM - Daniel Curtis

- Status changed from Resolved to Closed

#23 - 07/08/2015 12:15 PM - Daniel Curtis

- Description updated

#24 - 07/15/2015 04:50 PM - Daniel Curtis

- Description updated

#25 - 07/17/2015 08:06 AM - Daniel Curtis

- Description updated

#26 - 07/17/2015 08:30 AM - Daniel Curtis

- Description updated

#27 - 07/20/2015 04:28 PM - Daniel Curtis

- Description updated
#28 - 08/03/2015 12:09 PM - Daniel Curtis
- Description updated

#29 - 08/03/2015 01:06 PM - Daniel Curtis
- Description updated

#30 - 01/12/2016 01:33 PM - Daniel Curtis
- Subject changed from Install Odoo on FreeBSD to Install Odoo 8 on FreeBSD

#31 - 01/12/2016 02:26 PM - Daniel Curtis
- Description updated
